/* 
 * Written 1993 by Amir Guindehi (amir@avalon.unizh.ch).
 *
 * For free use and distribution.
 * Thanks to Matt Watson for cleaning up this file.
 *
 * Folks, write driver inspectors ! 
 *
 * SoundBlaster IOAudio Driver Inspector File
 */

#import <appkit/appkit.h>

#import "IOsb8DeviceInspector.h"
#import "Config.h"

@implementation IOsb8DeviceInspector

// Since we have an accessory view, we load the nib here
// and set let the generic inspector know about it.
- loadMainNibFile
{
   char buff[MAXPATHLEN];
      
   [super loadMainNibFile];
   if (![[NXBundle bundleForClass: [self class]] getPath: buff
	    forResource:"SoundBlaster8" ofType:"nib"]) {
      NXLogError("Couldn't load inspector nib");
      [self free];
      return nil;
   }
   if (![NXApp loadNibFile:buff owner:self withNames:NO]) {
      [self free];
      return nil;
   }
   [self setAccessoryView:sbView];

   // Make sure we update the table when the user tabs around
   [keyUser setTextDelegate:self];
   [keyEmail setTextDelegate:self];
   [keyCode setTextDelegate:self];
   
   return self;
}

// This gets called by the Configure app after we've loaded our nib
// but before it gets displayed.  
- setTable: (NXStringTable *)instance
{
  [super setTable:instance];
  [keyUser setStringValue:[table valueForStringKey:KEY_USER_STR]];
  [keyEmail setStringValue:[table valueForStringKey:KEY_EMAIL_STR]];
  [keyCode setStringValue:[table valueForStringKey:KEY_CODE_STR]];
  [debugSwitch setState:*[table valueForStringKey:DEBUG_FLAG_STR] == 'Y'];

  return self;
}

- keyChanged: sender
{
   char *oldStr, *newStr;
   
   newStr = NXCopyStringBuffer([keyUser stringValue]);
   oldStr = [table insertKey:KEY_USER_STR value:newStr];
   NX_FREE(oldStr);
   newStr = NXCopyStringBuffer([keyEmail stringValue]);
   oldStr = [table insertKey:KEY_EMAIL_STR value:newStr];
   NX_FREE(oldStr);
   newStr = NXCopyStringBuffer([keyCode stringValue]);
   oldStr = [table insertKey:KEY_CODE_STR value:newStr];
   NX_FREE(oldStr);
   return self;
}

- debugChanged: sender {

  [table insertKey:DEBUG_FLAG_STR value:[sender state] ? "YES" : "NO"];
  return self;
}

- textDidEnd:textObject endChar:(unsigned short)whyEnd {

   [self keyChanged:self];
   return self;
}
@end
